--global variables
WorldsWorldDifficulty = {}

function Initialize(Plugin)
	Plugin:SetName("Difficulties")
	Plugin:SetVersion(2)

	PluginManager = cRoot:Get():GetPluginManager()
	PluginManager:AddHook(cPluginManager.HOOK_SPAWNING_ENTITY, OnSpawningEntity)
      PluginManager:AddHook(cPluginManager.HOOK_TAKE_DAMAGE, OnTakeDamage)

	PluginManager:BindCommand("/difficulty",            "difficulties.difficulty",            HandleDifficultyCommand,            " ~ Change server difficulty")

	cRoot:Get():ForEachWorld(
		function (a_World)
			WorldIni = cIniFile(a_World:GetIniFileName())
			if WorldIni:ReadFile() then
				WorldsWorldDifficulty[a_World:GetName()]   = WorldIni:GetValueSetI("Difficulty",   "WorldDifficulty",   2)
				WorldIni:WriteFile()
			end
		end
	)

	LOG("Initialized " .. Plugin:GetName() .. " v." .. Plugin:GetVersion())
	return true
end


function HandleDifficultyCommand ( Split, Player )

	if( #Split ~= 2 ) then
		Player:SendMessage( "Usage: /difficulty [peaceful|easy|normal|hard]" )
		return true
	end

	if (Split[2] == "peaceful") or (Split[2] == "0") or (Split[2] == "p") then
            WorldIni:DeleteValue("Difficulty",   "WorldDifficulty")
            WorldIni:SetValue("Difficulty",   "WorldDifficulty",   0)
            WorldIni:WriteFile()
		Player:SendMessage( "World difficulty set to peaceful" )
            return true
	elseif (Split[2] == "easy") or (Split[2] == "1") or (Split[2] == "e") then
            WorldIni:DeleteValue("Difficulty",   "WorldDifficulty")
		WorldIni:SetValue("Difficulty",   "WorldDifficulty",   1)
            WorldIni:WriteFile()
		Player:SendMessage( "World difficulty set to easy" )
            return true
	elseif (Split[2] == "normal") or (Split[2] == "2") or (Split[2] == "n") then
            WorldIni:DeleteValue("Difficulty",   "WorldDifficulty")
		WorldIni:SetValue("Difficulty",   "WorldDifficulty",   2)
            WorldIni:WriteFile()
		Player:SendMessage( "World difficulty set to normal" )
            return true
	elseif (Split[2] == "hard") or (Split[2] == "3") or (Split[2] == "h") then
            WorldIni:DeleteValue("Difficulty",   "WorldDifficulty")
		WorldIni:SetValue("Difficulty",   "WorldDifficulty",   3)
            WorldIni:WriteFile()
		Player:SendMessage( "World difficulty set to hard" )
            return true
      else
		Player:SendMessage( "Usage: /difficulty [peaceful|easy|normal|hard]" )
            return true
	end
end